import static gdbutil.ConnectionParameters.*;

import java.util.HashMap;
import java.util.Iterator;

import org.geotools.data.DataStore;
import org.geotools.data.DataStoreFactorySpi;
import org.geotools.data.DataStoreFinder;
import org.geotools.data.simple.SimpleFeatureSource;
import org.geotools.data.simple.SimpleFeatureCollection;
import org.geotools.data.simple.SimpleFeatureIterator;
import org.opengis.feature.simple.SimpleFeature;
import org.opengis.feature.simple.SimpleFeatureType;

import com.vividsolutions.jts.geom.Geometry;

/**
 * Beispielsprogramm zur Demonstration des Zugriffs mit GeoTools.
 *
 * @author: Thomas Brinkhoff
 */
public class GeotoolsExample {

	public static void main(String[] args) {
		try {
	        // Datastores anzeigen
	        /*Iterator<DataStoreFactorySpi> dsit = DataStoreFinder.getAllDataStores();
	        while (dsit.hasNext()) {
	        	DataStoreFactorySpi ds = dsit.next();
	        	System.out.println(ds.getDisplayName());
	        };*/
			// Verbindung spezifizieren
	        HashMap<String,String> m = new HashMap<String,String>();
	        m.put("dbtype","oracle");
	        m.put("host",DBHOST);
	        m.put("port",DBPORT);
	        m.put("database",DBNAME);
	        m.put("user",DBUSER);
	        m.put("passwd",DBPASSWORD);
	        m.put("schema",DBUSER.toUpperCase());
	        // Datastore bestimmen
			DataStore store = DataStoreFinder.getDataStore(m);
			/*String layerNamen[] = store.getTypeNames();
			for (String name : layerNamen)
				System.out.println(name);*/
	        // Tabelle auswhlen und einlesen
			SimpleFeatureSource fSource = store.getFeatureSource("ORTSNETZE");
			SimpleFeatureCollection res = fSource.getFeatures();
			SimpleFeatureIterator it = res.features();
			while (it.hasNext()) {
				SimpleFeature obj = it.next();
				Geometry geom = (Geometry)obj.getDefaultGeometry();
				if (geom != null)
					System.out.println(obj.getAttribute("NAME")+/*" "+obj.getID()+*/": "+geom.getArea());
			}
			it.close();
		}
		// Fehlerbehandlung
		catch (Exception ex) {
			System.err.println("GeotoolsExample.main: "+ex);
		}
	}
}
