/**
 * Beispielsprogramm zur Demonstration des JDBC-APIs bei Objekten (Structs).
 *
 * @author: Thomas Brinkhoff
 * @version: 1.00
 */

import static gdbutil.ConnectionParameters.*;

import java.math.BigDecimal;
import java.sql.*;		// Import der Klassen des Pakets "java.sql.*"

public class JdbcStructExample {

public static void main (String[] args) {
	try {
		// Verbindung zur Datenbank aufbauen
		//Class.forName("oracle.jdbc.driver.OracleDriver");  // ab JDK6 entbehrlich
		String url = "jdbc:oracle:thin:@" + DBHOST + ":" + DBPORT + ":" + DBNAME;  // JDBC Thin Driver
			// bei JDBC OCI Driver:  "jdbc:oracle:oci:@" + DBSERVICENAME;
		Connection db = DriverManager.getConnection(url, DBUSER, DBPASSWORD);

		// Anfrage ausfhren
		Statement statement = db.createStatement();
		String sql = "SELECT geo FROM GeoDbLand WHERE name = 'Steg'";
		ResultSet result = statement.executeQuery(sql);
		if (result.next()) {
			Struct geo = (Struct)result.getObject("geo");
			Object[] attr = geo.getAttributes();
			BigDecimal gtype = (BigDecimal)attr[0];
			System.out.println("gtype: "+gtype);
			Array ordinates = (Array)attr[4];
			BigDecimal ordArray[] = (BigDecimal[])ordinates.getArray();
			System.out.print("ordinates: ");
			for (BigDecimal ord : ordArray)
			   System.out.print(ord+" ");
			System.out.println();   
		}
		result.close();
		statement.close();

		// Verbindung schlieen
		db.close();
	} // try

	// Fehlerbehandlung:
	catch (Exception ex) {
		System.err.println("JdbcStructExample.main: "+ex);
	}
}
}
